
(function(root, factory) {

if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('logtown').getLogger('/src/handlers/RetrieveFundingAccountsHandler'), require('../ApiClient'), require('../api/FundingAccountApi'), require('../OrbipayApiError'), require('../CommonUtil'));
  } 
}(this, function(logger, ApiClient, FundingAccountApi, OrbipayApiError, CommonUtil) {
  'use strict';

  /**
   * @module ApiClient
   */

  /**
   * <h3 style="color:red"> This class subject to change without prior notice, Please dont use this class directly. </h3>

   * @module handlers/RetrieveFundingAccountsHandler
   * @class
   */

  var exports = function() {
  };

  exports.prototype.process = function (fundingAccounts, callback) {
        
        var secret = fundingAccounts.invocation_context.secret;
		var host = fundingAccounts.api_end_point;
        var api_key = fundingAccounts.invocation_context.api_key;
        var auth_scheme = fundingAccounts.invocation_context.auth_scheme;
        var _this=this;
		var response = {};
        var exception;
        try {
            var api_client = new ApiClient(secret, host,api_key,auth_scheme);
			var api_instance = new FundingAccountApi(api_client);
			var channel = fundingAccounts.invocation_context['channel'];
			var client_key = fundingAccounts.invocation_context['client_key'];
			var product = fundingAccounts.invocation_context['product'];
			var timestamp;
			if (fundingAccounts.invocation_context['timestamp'])
			{
				timestamp = fundingAccounts.invocation_context['timestamp'];
			}		
			else
			{
				timestamp = CommonUtil.getTimeStamp();
			}
			var idempotent_request_key = fundingAccounts.invocation_context['idempotent_request_key'];
			var requestor_type = fundingAccounts.invocation_context['requestor_type'];
			var id_customer = fundingAccounts['ID_CUSTOMER'];
            var opts = _this.getOptions(fundingAccounts);
			var result = api_instance.retrieveFundingAccounts(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer,  opts, callback);
			response['request'] = result;
			return response;
        } catch (e) {
            exception = OrbipayApiError.getDefaultException(e);
            if (callback) {
                callback(null, null, null, exception);
            }
            response['exception'] = exception;
            return response;
        }
    };

    exports.prototype.getOptions = function (fundingAccounts) {
        return {
		    'requestor': fundingAccounts['invocation_context']['requestor'], 
		    'x_opay_headers': fundingAccounts['invocation_context']['X-OPAY-Headers'], 
		    'page_size': fundingAccounts['page_size'], 
		    'account_number': fundingAccounts['account_number'], 
		    'status': fundingAccounts['status'], 
		    'aba_routing_number': fundingAccounts['aba_routing_number'], 
		    'account_type': fundingAccounts['account_type'], 
		    'account_subtype': fundingAccounts['account_subtype']
        };
    };  


  return exports;
}));
