(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/CustomerAccountResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CustomerAccountResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.CustomersCustomerAccountsResponse = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.CustomerAccountResponse);
  }
}(this, function(ApiClient, CustomerAccountResponse) {
  'use strict';




  /**
   * The CustomersCustomerAccountsResponse model module.
   * @module models/CustomersCustomerAccountsResponse
   */

  /**
   * <h3 style="color:red"> This class subject to change without prior notice, Please dont use this class directly. </h3>

   * Constructs a new <code>CustomersCustomerAccountsResponse</code>.
   * @alias module:models/CustomersCustomerAccountsResponse
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>CustomersCustomerAccountsResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/CustomersCustomerAccountsResponse} obj Optional instance to populate.
   * @return {module:models/CustomersCustomerAccountsResponse} The populated <code>CustomersCustomerAccountsResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('list')) {
        obj['list'] = ApiClient.convertToType(data['list'], [CustomerAccountResponse]);
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
    }
    return obj;
  };

  /**
   * @member {Array.<module:models/CustomerAccountResponse>} list
   */
  exports.prototype['list'] = undefined;
  /**
   * This URL fetches the list of Customer accounts of a customer.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;



  return exports;
}));


